#!/usr/bin/awk -f
#
# improve the index


BEGIN{

	# special formating for entries
	e["mta"] = "Mail Transfer Agent (\\NAME{MTA})";
	e["mua"] = "Mail User Agent (\\NAME{MUA})";
	e["mda"] = "Mail Delivery Agent (\\NAME{MDA})";
	e["smtp"] = "Simple Mail Transfer Protocol (\\NAME{SMTP})";
	e["ietf"] = "ietf@\\NAME{IETF}";
	e["debian"] = "Debian";
	e["ascii"] = "ascii@\\NAME{ASCII}";
	e["gpl"] = "General Public License (\\NAME{GPL})";
	e["auth"] = "authentication";
	e["bsd"] = "Berkeley Software Distribution (\\NAME{BSD})";
	e["c"] = "C programming language";
	e["changing ip addresses"] = "changing \\NAME{IP} addresses";
	e["cyrus sasl"] = "cyrus \\NAME{SASL}";
	e["dns blacklist"] = "dns blacklist@\\NAME{DNS} blacklist";
	e["dynamic dns"] = "dynamic \\NAME{DNS}";
	e["enc"] = "encryption";
	e["fax"] = "telefax";
	e["imap"] = "imap@\\NAME{IMAP}";
	e["ipc"] = "Inter-Process Communication (\\NAME{IPC})";
	e["isp"] = "Internet Service Provider (\\NAME{ISP})";
	e["mime"] = "mime@\\NAME{MIME}";
	e["mmdf"] = "mmdf@\\NAME{MMDF}";
	e["pam"] = "pam@\\NAME{PAM}";
	e["pop3"] = "pop3@\\NAME{POP3}";
	e["relay-only mta"] = "relay-only \\NAME{MTA}";
	e["rfc"] = "Request for Comments (\\NAME{RFC})";
	e["sasl"] = "sasl@\\NAME{SASL}";
	e["smtps"] = "smtps@\\NAME{SMTPS}";
	e["starttls"] = "starttls@\\NAME{STARTTLS}";
	e["swot analysis"] = "swot analysis@\\NAME{SWOT} analysis";
	e["tcp socket"] = "tcp socket@\\NAME{TCP} socket";
	e["tcp wrapper"] = "tcp wrapper@\\NAME{TCP} Wrapper";
	e["tls"] = "Transport Layer Security (\\NAME{TLS})";
	e["uc"] = "Unified Communication";
	e["um"] = "Unified Messaging";
	e["uucp"] = "uucp@\\NAME{UUCP}";
	e["setuid"] = "setuid/setgid";


	# persons
	e["Oliver Kurth"] = e["Kurth"] = "Kurth@\\textsc{Kurth, Oliver}";
	e["Adam Back"] = e["Back"] = "Back@\\textsc{Back, Adam}";
	e["Eric Allman"] = e["Allman"] = "Allman@\\textsc{Allman, Eric}";
	e["Stas Bekman"] = e["Bekman"] = "Bekman@\\textsc{Bekman, Stas}";
	e["Daniel J. Bernstein"] = e["Bernstein"] = "Bernstein@\\textsc{Bernstein, Daniel J.}";
	e["Bryan Costales"] = e["Costales"] = "Costales@\\textsc{Costales, Bryan}";
	e["George Candea"] = e["Candea"] = "Candea@\\textsc{Candea, George}";
	e["Dan Shearer"] = e["Shearer"] = "Shearer@\\textsc{Shearer, Dan}";
	e["Dave Sill"] = e["Sill"] = "Sill@\\textsc{Sill, Dave}";
	e["David A. Wheeler"] = e["Wheeler"] = "Wheeler@\\textsc{Wheeler, David A.}";
	e["Kyle D. Dent"] = e["Dent"] = "Dent@\\textsc{Dent, Kyle D.}";
	e["Derek Broughton"] = e["Broughton"] = "Broughton@\\textsc{Broughton, Derek}";
	e["Doug McIlroy"] = e["McIlroy"] = "McIlroy@\\textsc{McIlroy, Doug}";
	e["Peter Eisentraut"] = e["Eisentraut"] = "Eisentraut@\\textsc{Eisentraut, Peter}";
	e["Tony Finch"] = e["Finch"] = "Finch@\\textsc{Finch, Tony}";
	e["Armando Fox"] = e["Fox"] = "Fox@\\textsc{Fox, Armando}";
	e["Frederik Vermeulen"] = e["Vermeulen"] = "Vermeulen@\\textsc{Vermeulen, Frederik}";
	e["Marc G. Graff"] = e["Graff"] = "Graff@\\textsc{Graff, Marc G.}";
	e["Munawar Hafiz"] = e["Hafiz"] = "Hafiz@\\textsc{Hafiz, Munawar}";
	e["Philip Hazel"] = e["Hazel"] = "Hazel@\\textsc{Hazel, Philip}";
	e["Ian R. Justman"] = e["Justman"] = "Justman@\\textsc{Justman, Ian R.}";
	e["Jesse Freund"] = e["Freund"] = "Freund@\\textsc{Freund, Jesse}";
	e["Jon Postel"] = e["Postel"] = "Postel@\\textsc{Postel, Jon}";
	e["Jonathan de Boyne Pollard"] = e["de Boyne Pollard"] = "de Boyne Pollard@\\textsc{de Boyne Pollard, Jonathan}";
	e["Stephen H. Kan"] = e["Kan"] = "Kan@\\textsc{Kan, Stephen H.}";
	e["Brian W. Kernighan"] = e["Kernighan"] = "Kernighan@\\textsc{Kernighan, Brian W.}";
	e["Nils Lenke"] = e["Lenke"] = "Lenke@\\textsc{Lenke, Nils}";
	e["Markus Schnalke"] = e["Schnalke"] = "Schnalke@\\textsc{Schnalke, Markus}";
	e["Michael Osterman"] = e["Osterman"] = "Osterman@\\textsc{Osterman, Michael}";
	e["Rob Pike"] = e["Pike"] = "Pike@\\textsc{Pike, Rob}";
	e["Eric S. Raymond"] = e["Raymond"] = "Raymond@\\textsc{Raymond, Eric S.}";
	e["Dennis Ritchie"] = e["Ritchie"] = "Ritchie@\\textsc{Ritchie, Dennis}";
	e["Peter Schmitz"] = e["Schmitz"] = "Schmitz@\\textsc{Schmitz, Peter}";
	e["Ken Simpson"] = e["Simpson"] = "Simpson@\\textsc{Simpson, Ken}";
	e["Diomidis Spinellis"] = e["Spinellis"] = "Spinellis@\\textsc{Spinellis, Diomidis}";
	e["Andrew S. Tanenbaum"] = e["Tanenbaum"] = "Tanenbaum@\\textsc{Tanenbaum, Andrew S.}";
	e["Kenneth R. van Wyk"] = e["van Wyk"] = "van Wyk@\\textsc{van Wyk, Kenneth R.}";
	e["Christian Langbein"] = e["Langbein"] = "Langbein@\\textsc{Langbein, Christian}";
	e["Dad"] = "Schnalke@\\textsc{Schnalke, R\\\"udiger}";
	e["Hans-J\\\"org Schaaf"] = e["Schaaf"] = "Schaaf@\\textsc{Schaaf, Hans-J\\\"org}";
	e["Henry Atting"] = e["Atting"] = "Atting@\\textsc{Atting, Henry}";
	e["Heraclitus"] = "Heraclitus@\\textsc{Heraclitus}";
	e["James Stenard"] = e["Stenard"] = "Stenard@\\textsc{Stenard, James}";
	e["Joachim Breitner"] = e["Breitner"] = "Breitner@\\textsc{Breitner, Joachim}";
	e["Jochen Roth"] = e["Roth"] = "Roth@\\textsc{Roth, Jochen}";
	e["Julian Forster"] = e["Forster"] = "Forster@\\textsc{Forster, Julian}";
	e["Lydi"] = "Steffan@\\textsc{Steffan, Lydi}";
	e["Marc Geis"] = e["Geis"] = "Geis@\\textsc{Geis, Marc}";
	e["Markus Sch\\\"affter"] = e["Sch\\\"affter"] = "Schaeffter@\\textsc{Sch\\\"affter, Markus}";
	e["Roger Schietzel"] = e["Schietzel"] = "Schietzel@\\textsc{Schietzel, Roger}";
	e["Stephen C. Johnson"] = e["Johnson"] = "Johnson@\\textsc{Johnson, Stephen C.}";
	e["Wietse Venema"] = e["Venema"] = "Venema@\\textsc{Venema, Wietse}";
	e["Volkmar Kese"] = e["Kese"] = "Kese@\\textsc{Kese, Volkmar}";
	e["Wolfgang Leister"] = e["Leister"] = "Leister@\\textsc{Leister, Wolfgang}";


	# subentries
	s["sendmailx"] = "sendmail X";
	s["meta1"] = "MeTA1";
	s["smtp-after-pop"] = "\\NAME{SMTP}-after-\\NAME{POP}";
	s["smtp-auth"] = "\\NAME{SMTP-AUTH}";


	# aliases
	a["ifdef"] = "ifdef|see{conditional compilation}";
	a["envelope"] = "envelope|see{mail message}";
	a["header"] = "header|see{mail message}";
	a["body"] = "body|see{mail message}";
	a["ssl"] = "ssl@\\NAME{SSL}|see{\\NAME{TLS}}";
	a["forwarder"] = "forwarder|see{relay-only \\NAME{MTA}}";
	a["junk mail"] = "junk mail|see{spam}";
	a["fax"] = "fax|see{telefax}";

}



{
	gsub(/\\ /, " ");
	gsub(/\\nobreakspace  \{\}/, " ");
	gsub(/\\discretionary \{-\}\{\}\{\}/, "");

	entry = $0
	sub(/[^{]*{/, "", entry);
	sub(/[}!].*/, "", entry);
	if (e[entry]) {
		sub(/{[^}!]*/, "{" e[entry]);
	}

	subentry = $0
	sub(/[^!]*!/, "", subentry);
	sub(/}.*/, "", subentry);
	if (s[subentry]) {
		sub(/![^}]*/, "!" s[subentry]);
	}

	print;
}



END {
	# aliases
	for (i in a) {
		print "\\indexentry{" a[i] "}{0}";
	}
}
